/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GetCampaignSendoutStarts200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetCampaignSendoutStarts200Response{}

// GetCampaignSendoutStarts200Response struct for GetCampaignSendoutStarts200Response
type GetCampaignSendoutStarts200Response struct {
	Results *GetCampaignSendoutStarts200ResponseResults `json:"results,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewGetCampaignSendoutStarts200Response instantiates a new GetCampaignSendoutStarts200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetCampaignSendoutStarts200Response() *GetCampaignSendoutStarts200Response {
	this := GetCampaignSendoutStarts200Response{}
	return &this
}

// NewGetCampaignSendoutStarts200ResponseWithDefaults instantiates a new GetCampaignSendoutStarts200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetCampaignSendoutStarts200ResponseWithDefaults() *GetCampaignSendoutStarts200Response {
	this := GetCampaignSendoutStarts200Response{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200Response) GetResults() GetCampaignSendoutStarts200ResponseResults {
	if o == nil || IsNil(o.Results) {
		var ret GetCampaignSendoutStarts200ResponseResults
		return ret
	}
	return *o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200Response) GetResultsOk() (*GetCampaignSendoutStarts200ResponseResults, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200Response) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given GetCampaignSendoutStarts200ResponseResults and assigns it to the Results field.
func (o *GetCampaignSendoutStarts200Response) SetResults(v GetCampaignSendoutStarts200ResponseResults) {
	o.Results = &v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200Response) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200Response) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200Response) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *GetCampaignSendoutStarts200Response) SetTotal(v int32) {
	o.Total = &v
}

func (o GetCampaignSendoutStarts200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetCampaignSendoutStarts200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableGetCampaignSendoutStarts200Response struct {
	value *GetCampaignSendoutStarts200Response
	isSet bool
}

func (v NullableGetCampaignSendoutStarts200Response) Get() *GetCampaignSendoutStarts200Response {
	return v.value
}

func (v *NullableGetCampaignSendoutStarts200Response) Set(val *GetCampaignSendoutStarts200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetCampaignSendoutStarts200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetCampaignSendoutStarts200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetCampaignSendoutStarts200Response(val *GetCampaignSendoutStarts200Response) *NullableGetCampaignSendoutStarts200Response {
	return &NullableGetCampaignSendoutStarts200Response{value: val, isSet: true}
}

func (v NullableGetCampaignSendoutStarts200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetCampaignSendoutStarts200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


